package sun.reflect;

import java.lang.reflect.Field;

class UnsafeQualifiedStaticDoubleFieldAccessorImpl extends UnsafeQualifiedStaticFieldAccessorImpl
{
    UnsafeQualifiedStaticDoubleFieldAccessorImpl(Field field, boolean b) {
        super(field, b);
    }
    
    @Override
    public Object get(Object o) throws IllegalArgumentException {
        return new Double(this.getDouble(o));
    }
    
    @Override
    public boolean getBoolean(Object o) throws IllegalArgumentException {
        throw this.newGetBooleanIllegalArgumentException();
    }
    
    @Override
    public byte getByte(Object o) throws IllegalArgumentException {
        throw this.newGetByteIllegalArgumentException();
    }
    
    @Override
    public char getChar(Object o) throws IllegalArgumentException {
        throw this.newGetCharIllegalArgumentException();
    }
    
    @Override
    public short getShort(Object o) throws IllegalArgumentException {
        throw this.newGetShortIllegalArgumentException();
    }
    
    @Override
    public int getInt(Object o) throws IllegalArgumentException {
        throw this.newGetIntIllegalArgumentException();
    }
    
    @Override
    public long getLong(Object o) throws IllegalArgumentException {
        throw this.newGetLongIllegalArgumentException();
    }
    
    @Override
    public float getFloat(Object o) throws IllegalArgumentException {
        throw this.newGetFloatIllegalArgumentException();
    }
    
    @Override
    public double getDouble(Object o) throws IllegalArgumentException {
        return UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.getDoubleVolatile(this.base, this.fieldOffset);
    }
    
    @Override
    public void set(Object o, Object o2) throws IllegalArgumentException, IllegalAccessException {
        if (this.isReadOnly) {
            this.throwFinalFieldIllegalAccessException(o2);
        }
        if (o2 == null) {
            this.throwSetIllegalArgumentException(o2);
        }
        if ((o2 instanceof Byte)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)(byte)o2);
            return;
        }
        if ((o2 instanceof Short)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)(short)o2);
            return;
        }
        if ((o2 instanceof Character)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)(char)o2);
            return;
        }
        if ((o2 instanceof Integer)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)(int)o2);
            return;
        }
        if ((o2 instanceof Long)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)(long)o2);
            return;
        }
        if ((o2 instanceof Float)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)(float)o2);
            return;
        }
        if ((o2 instanceof Double)) {
            UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, (double)o2);
            return;
        }
        this.throwSetIllegalArgumentException(o2);
        return;
    }
    
    @Override
    public void setBoolean(Object o, boolean b) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(b);
    }
    
    @Override
    public void setByte(Object o, byte b) throws IllegalArgumentException, IllegalAccessException {
        this.setDouble(o, (double)b);
    }
    
    @Override
    public void setChar(Object o, char c) throws IllegalArgumentException, IllegalAccessException {
        this.setDouble(o, (double)c);
    }
    
    @Override
    public void setShort(Object o, short n) throws IllegalArgumentException, IllegalAccessException {
        this.setDouble(o, (double)n);
    }
    
    @Override
    public void setInt(Object o, int n) throws IllegalArgumentException, IllegalAccessException {
        this.setDouble(o, (double)n);
    }
    
    @Override
    public void setLong(Object o, long n) throws IllegalArgumentException, IllegalAccessException {
        this.setDouble(o, (double)n);
    }
    
    @Override
    public void setFloat(Object o, float n) throws IllegalArgumentException, IllegalAccessException {
        this.setDouble(o, (double)n);
    }
    
    @Override
    public void setDouble(Object o, double x) throws IllegalArgumentException, IllegalAccessException {
        if (this.isReadOnly) {
            this.throwFinalFieldIllegalAccessException(x);
        }
        UnsafeQualifiedStaticDoubleFieldAccessorImpl.unsafe.putDoubleVolatile(this.base, this.fieldOffset, x);
    }
}
